﻿Imports System.IO

Public Class Form1
    'エディタ関数の変数
    Private fileFilter As String = "テキスト文書|*.txt|すべてのファイル|*.*"
    Private currentFileName As String
    Private title As String = "memo"
    Private FileName As String = "新規文書"
    Private newFileName As String = "新規文書"
    Private textIsDirty As Boolean

    '印刷関連の変数
    Private headerFont As New Font("MS UI Gothic", 8)
    Private currentPageNumber As Integer

    '検索/置換関連の変数
    Public StrFind As String = ""
    Private strReplace As String = ""

    'DATAファイルの変数
    Public datPath As String = My.Application.Info.DirectoryPath & "\memo.dat"   'memo.exe内フォルダ
    Public dat(10) As String
    'ヘルプ用の変数
    Private helpFileName As String = "memo.html"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'フォームの設定
        Me.Width = 464
        Me.Height = 452
        Me.MinimumSize = New Size(464, 452)

        'テキストエディタ関連の設定
        textIsDirty = False
        Me.Text = title & " : " & newFileName
        currentFileName = newFileName

        'DATAファイル初期内容
        dat(0) = "MS UI Gothic"     'フォント名
        dat(1) = "9"                'フォントサイズ
        dat(2) = "False"            'BOLD
        dat(3) = "False"            'ITALIC
        dat(4) = "shift-jis"        '文字コード

        'DATAファイルの読み込み
        Try
            Dim fs As New FileStream(datPath, FileMode.OpenOrCreate)
            fs.Close()
        Catch ex As Exception
            MessageBox.Show("DATAファイルが作成できません。", "注意", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Me.Close()
        End Try

        Using reader As StreamReader = New StreamReader(datPath, System.Text.Encoding.GetEncoding("shift-jis"))
            Dim line As String
            Dim num01 As Integer
            num01 = 0
            Do
                line = reader.ReadLine
                If Not line Is Nothing Then
                    dat(num01) = ""
                    dat(num01) = line
                    num01 = num01 + 1
                End If
            Loop Until reader.Peek = -1 Or num01 = 5
        End Using

        If dat(2) = "False" Then
            If dat(3) = "False" Then
                TextBox1.Font = New Font(dat(0), Single.Parse(dat(1)), FontStyle.Regular)
            End If
        End If
        If dat(2) = "False" Then
            If dat(3) = "True" Then
                TextBox1.Font = New Font(dat(0), Single.Parse(dat(1)), FontStyle.Italic)
            End If
        End If
        If dat(2) = "True" Then
            If dat(3) = "False" Then
                TextBox1.Font = New Font(dat(0), Single.Parse(dat(1)), FontStyle.Bold)
            End If
        End If
        If dat(2) = "True" Then
            If dat(3) = "True" Then
                TextBox1.Font = New Font(dat(0), Single.Parse(dat(1)), FontStyle.Bold Or FontStyle.Italic)
            End If
        End If
        If dat(4) = "shift-jis" Then
            mnuOptionEncodeSJIS.Checked = True
            mnuOptionEncodeUnicode.Checked = False
        End If
        If dat(4) = "Unicode" Then
            mnuOptionEncodeSJIS.Checked = False
            mnuOptionEncodeUnicode.Checked = True
        End If

        'ショートカットからのファイル読み込み
        Dim path As String
        Try
            path = My.Application.CommandLineArgs.Item(0)
        Catch ex As Exception
            path = ""
        End Try
        If path <> "" Then
            Using reader As New StreamReader(path, System.Text.Encoding.GetEncoding(dat(4)))
                TextBox1.Text = reader.ReadToEnd
                textIsDirty = False
                currentFileName = path
                Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(path).Name
                FileName = My.Computer.FileSystem.GetFileInfo(path).Name
                OpenFileDialog1.FileName = FileName
                OpenFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(path).DirectoryName
                SaveFileDialog1.FileName = FileName
                SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(path).DirectoryName
            End Using
        End If
    End Sub

    'テキストエディタのメニューハンドラ
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    Private Sub mnuEditUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditUndo.Click
        EditUndo()
    End Sub

    Private Sub mnuEditCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditCut.Click
        EditCut()
    End Sub

    Private Sub mnuEditCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditCopy.Click
        EditCopy()
    End Sub

    Private Sub mnuEditPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditPaste.Click
        EditPaste()
    End Sub

    Private Sub mnuEditSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditSelectAll.Click
        EditSelectAll()
    End Sub

    Private Sub mnuEdit_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles mnuEdit.MouseDown
        If TextBox1.CanUndo Then
            mnuEditUndo.Enabled = True
        Else
            mnuEditUndo.Enabled = False
        End If
        If TextBox1.SelectionLength > 0 Then
            mnuEditCopy.Enabled = True
            mnuEditCut.Enabled = True
        Else
            mnuEditCopy.Enabled = False
            mnuEditCut.Enabled = False
        End If
        If My.Computer.Clipboard.GetDataObject().GetDataPresent(DataFormats.Text) Then
            mnuEditPaste.Enabled = True
        Else
            mnuEditPaste.Enabled = False
        End If
    End Sub

    Private Sub mnuOptionFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOptionFont.Click
        OptionFont()
    End Sub

    Private Sub mnuOptionEncodeSJIS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOptionEncodeSJIS.Click
        OptionEncodeSJIS()
    End Sub

    Private Sub mnuOptionEncodeUnicode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOptionEncodeUnicode.Click
        OptionEncodeUnicode()
    End Sub

    Private Sub mnuFileNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileNew.Click
        FileNew()
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        FileOpen()
    End Sub

    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click
        FileSave()
    End Sub

    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click
        FileSaveAs()
    End Sub

    Private Sub mnuFilePageSetup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFilePageSetup.Click
        PrintPageSetup()
    End Sub

    Private Sub mnuFilePreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFilePreview.Click
        PrintPreview()
    End Sub

    Private Sub mnuFilePrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFilePrint.Click
        PrintPrint()
    End Sub

    Private Sub mnuEditFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditFind.Click
        EditFind()
    End Sub

    Private Sub mnuEditReplace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditReplace.Click
        EditReplace()
    End Sub

    Private Sub mnuHelpIndex_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpIndex.Click
        HelpIndex()
    End Sub

    Private Sub mnuHelpAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpAbout.Click
        HelpAbout()
    End Sub

    'テキストエディタ編集処理
    Private Sub EditUndo()
        TextBox1.Undo()
    End Sub

    Private Sub EditCut()
        If TextBox1.SelectedText <> "" Then
            TextBox1.Cut()
        End If
    End Sub

    Private Sub EditCopy()
        If TextBox1.SelectedText <> "" Then
            TextBox1.Copy()
        End If
    End Sub

    Private Sub EditPaste()
        If My.Computer.Clipboard.GetDataObject.GetDataPresent(DataFormats.Text) Then
            TextBox1.Paste()
        End If
    End Sub

    Private Sub EditSelectAll()
        TextBox1.SelectAll()
    End Sub

    'フォントの設定
    Private Sub OptionFont()
        FontDialog1.Font = TextBox1.Font
        If FontDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            If FontDialog1.Font.Bold = False Then
                If FontDialog1.Font.Italic = False Then
                    TextBox1.Font = New Font(FontDialog1.Font, FontStyle.Regular)
                End If
            End If
            If FontDialog1.Font.Bold = False Then
                If FontDialog1.Font.Italic = True Then
                    TextBox1.Font = New Font(FontDialog1.Font, FontStyle.Italic)
                End If
            End If
            If FontDialog1.Font.Bold = True Then
                If FontDialog1.Font.Italic = False Then
                    TextBox1.Font = New Font(FontDialog1.Font, FontStyle.Bold)
                End If
            End If
            If FontDialog1.Font.Bold = True Then
                If FontDialog1.Font.Italic = True Then
                    TextBox1.Font = New Font(FontDialog1.Font, FontStyle.Bold Or FontStyle.Italic)
                End If
            End If

            'ファイルに保存
            dat(0) = TextBox1.Font.Name
            dat(1) = TextBox1.Font.Size.ToString
            dat(2) = TextBox1.Font.Bold.ToString
            dat(3) = TextBox1.Font.Italic.ToString

            Dim num01 As Integer
            Using writer As New StreamWriter(datPath, False, System.Text.Encoding.GetEncoding("shift-jis"))
                For num01 = 0 To 4
                    writer.WriteLine(dat(num01))
                Next
            End Using
        End If
    End Sub

    '文字コードの設定
    Private Sub OptionEncodeSJIS()
        dat(4) = "shift-jis"
        mnuOptionEncodeSJIS.Checked = True
        mnuOptionEncodeUnicode.Checked = False

        Dim num01 As Integer
        Using writer As New StreamWriter(datPath, False, System.Text.Encoding.GetEncoding("shift-jis"))
            For num01 = 0 To 4
                writer.WriteLine(dat(num01))
            Next
        End Using
    End Sub

    Private Sub OptionEncodeUnicode()
        dat(4) = "Unicode"
        mnuOptionEncodeSJIS.Checked = False
        mnuOptionEncodeUnicode.Checked = True

        Dim num01 As Integer
        Using writer As New StreamWriter(datPath, False, System.Text.Encoding.GetEncoding("shift-jis"))
            For num01 = 0 To 4
                writer.WriteLine(dat(num01))
            Next
        End Using
    End Sub

    'テキストエディタのファイル操作
    Private Sub FileNew()
        If textIsDirty Then
            Dim result As DialogResult
            result = MessageBox.Show("編集中の文書を保存せずに閉じますか?", "memo", MessageBoxButtons.YesNo)
            If result <> Windows.Forms.DialogResult.Yes Then
                Return
            End If
        End If
        TextBox1.Clear()
        textIsDirty = False
        Me.Text = title & " : " & newFileName
        FileName = newFileName
    End Sub

    Private Sub FileOpen()
        If textIsDirty Then
            Dim result As DialogResult
            result = MessageBox.Show("編集中の文書を保存せずに閉じますか?", "memo", MessageBoxButtons.YesNo)
            If result <> Windows.Forms.DialogResult.Yes Then
                Return
            End If
        End If
        OpenFileDialog1.Filter = fileFilter

        'ファイル名初期化-----------------------------------
        If OpenFileDialog1.FileName = "OpenFileDialog1" Then
            OpenFileDialog1.FileName = ""
        End If
        '---------------------------------------------------

        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Using reader As New StreamReader(OpenFileDialog1.FileName, System.Text.Encoding.GetEncoding(dat(4)))
                TextBox1.Text = reader.ReadToEnd
                textIsDirty = False
                currentFileName = OpenFileDialog1.FileName
                Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(currentFileName).Name
                FileName = My.Computer.FileSystem.GetFileInfo(currentFileName).Name
                OpenFileDialog1.FileName = FileName
                OpenFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
                SaveFileDialog1.FileName = FileName
                SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
            End Using
        End If
    End Sub

    Private Sub FileSave()
        If FileName = newFileName Then
            FileSaveAs()
            Return
        End If
        Using writer As New StreamWriter(currentFileName, False, System.Text.Encoding.GetEncoding(dat(4)))
            writer.Write(TextBox1.Text)
            textIsDirty = False
            Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(currentFileName).Name
        End Using
    End Sub

    Private Sub FileSaveAs()
        Dim fileisnew As Boolean = False
        If FileName = newFileName Then
            FileName = "memo-" + DateTime.Now.ToString("yyyyMMdd-HHmmss") & ".txt"
            fileisnew = True
        End If
        SaveFileDialog1.FileName = FileName
        SaveFileDialog1.OverwritePrompt = False
        SaveFileDialog1.Filter = fileFilter
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            If File.Exists(SaveFileDialog1.FileName) Then
                Dim result As DialogResult
                result = MessageBox.Show("同じ名前のファイルがあります。上書きしますか?", "ファイルの新規作成", MessageBoxButtons.YesNo)
                If result <> Windows.Forms.DialogResult.Yes Then Return
            End If
            Using writer As New StreamWriter(SaveFileDialog1.FileName, False, System.Text.Encoding.GetEncoding(dat(4)))
                writer.Write(TextBox1.Text)
                textIsDirty = False
                currentFileName = SaveFileDialog1.FileName
                Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(currentFileName).Name
                FileName = My.Computer.FileSystem.GetFileInfo(currentFileName).Name
                OpenFileDialog1.FileName = FileName
                OpenFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
                SaveFileDialog1.FileName = FileName
                SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(currentFileName).DirectoryName
            End Using
        Else
            If fileisnew Then
                FileName = newFileName
            End If
        End If
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        If textIsDirty = False Then
            textIsDirty = True
            Me.Text = Me.Text & "*"
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If textIsDirty Then
            Dim result As DialogResult
            result = MessageBox.Show("編集中の作業を保存せずに閉じますか?", "memo", MessageBoxButtons.YesNo)
            If result <> Windows.Forms.DialogResult.Yes Then
                e.Cancel = True
            End If
        End If
    End Sub

    'テキストエディタの印刷処理
    Private Sub PrintPageSetup()
        Try
            PageSetupDialog1.Document = PrintDocument1
            PageSetupDialog1.ShowDialog()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub PrintPreview()
        Try
            PrintPreviewDialog1.Document = PrintDocument1
            PrintPreviewDialog1.ShowDialog()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub PrintPrint()
        Try
            PrintDialog1.Document = PrintDocument1
            If PrintDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                PrintDocument1.Print()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        '文字列の印刷開始位置
        Static posStart As Integer

        'ヘッダーの印刷
        Dim headerString As String
        headerString = currentFileName
        e.Graphics.DrawString( _
          headerString, _
          headerFont, _
          Brushes.Black, _
          e.MarginBounds.Left, _
          e.MarginBounds.Top _
        )
        'ヘッダー領域の大きさを求める
        Dim headerAreaSize As SizeF
        headerAreaSize = e.Graphics.MeasureString(headerString, headerFont)
        'ヘッダーの下に罫線を描画
        Dim pointL As New PointF(e.MarginBounds.Left, e.MarginBounds.Top + headerAreaSize.Height)
        Dim pointR As New PointF(e.MarginBounds.Right, e.MarginBounds.Top + headerAreaSize.Height)
        e.Graphics.DrawLine(New Pen(Color.Black, 1), pointL, pointR)
        'フッターの印刷
        Dim footerString As String
        footerString = "PAGE: " & currentPageNumber.ToString
        Dim footerAreaSize As SizeF
        footerAreaSize = e.Graphics.MeasureString(footerString, headerFont)
        Dim footerTop As Single
        footerTop = e.MarginBounds.Bottom - footerAreaSize.Height
        e.Graphics.DrawString( _
          footerString, _
          headerFont, _
          Brushes.Black, _
          e.MarginBounds.Left, _
          footerTop _
        )
        'フッターの上に罫線を描画
        pointL.X = e.MarginBounds.Left
        pointL.Y = footerTop
        pointR.X = e.MarginBounds.Right
        pointR.Y = footerTop
        e.Graphics.DrawLine(New Pen(Color.Black, 1), pointL, pointR)

        '印刷
        Dim bodyString As String = TextBox1.Text.Substring(posStart)
        Dim paddingBody As Single
        paddingBody = TextBox1.Font.GetHeight(e.Graphics)
        Dim bodyHeight As Single
        bodyHeight = e.MarginBounds.Height - headerAreaSize.Height - paddingBody - footerAreaSize.Height - paddingBody
        Dim rectDraw As New RectangleF( _
          e.MarginBounds.Left, _
          e.MarginBounds.Top + headerAreaSize.Height + paddingBody, _
          e.MarginBounds.Width, _
          bodyHeight _
        )
        Dim fmt As New StringFormat(StringFormatFlags.LineLimit)
        e.Graphics.DrawString(bodyString, TextBox1.Font, Brushes.Black, rectDraw, fmt)
        '印刷した文字数の計測とHasMorePageのセット
        Dim numChars As Integer
        Dim numLines As Integer
        Dim bodyAreaSize As New SizeF(e.MarginBounds.Width, e.MarginBounds.Height)
        e.Graphics.MeasureString(bodyString, TextBox1.Font, bodyAreaSize, fmt, numChars, numLines)
        posStart += numChars
        If posStart < TextBox1.Text.Length Then
            e.HasMorePages = True
            currentPageNumber += 1
        Else
            e.HasMorePages = False
            posStart = 0
        End If

    End Sub

    'テキストエディタの検索と置換
    Private Sub EditFind()
        Dim dlgFind As New FindDialog
        dlgFind.Owner = Me
        dlgFind.StrFind = Me.StrFind
        dlgFind.Show()
        mnuEditFind.Enabled = False
        tbEditFind.Enabled = False
    End Sub

    Friend Sub EditFindNext()
        Dim findPos As Integer
        Dim currentPos As Integer = TextBox1.SelectionStart
        If TextBox1.SelectedText = StrFind Then
            currentPos += 1
        End If
        findPos = TextBox1.Text.IndexOf(StrFind, currentPos)
        If findPos > -1 Then
            TextBox1.Select(findPos, StrFind.Length)
            TextBox1.ScrollToCaret()
        Else
            MessageBox.Show("'" & StrFind & "'が見つかりません", "前方検索")
        End If
    End Sub

    Friend Sub EditFindPrev()
        Dim findPos As Integer
        Dim currentPos As Integer = TextBox1.SelectionStart
        If TextBox1.SelectedText = StrFind Then
            currentPos -= 1
            If currentPos < 0 Then
                MessageBox.Show("'" & StrFind & "'が見つかりません", "後方検索")
                Return
            End If
        End If
        findPos = TextBox1.Text.LastIndexOf(StrFind, currentPos)
        If findPos > -1 Then
            TextBox1.Select(findPos, StrFind.Length)
            TextBox1.ScrollToCaret()
        Else
            MessageBox.Show("'" & StrFind & "'が見つかりません", "後方検索")
        End If
    End Sub

    Private Sub EditReplace()
        Dim dlgReplace As New ReplaceDialog
        dlgReplace.StrFind = Me.StrFind
        dlgReplace.StrReplace = Me.strReplace
        If dlgReplace.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.StrFind = dlgReplace.StrFind
            Me.strReplace = dlgReplace.StrReplace
        Else
            Return
        End If
        If StrFind.Length = 0 Then
            Return
        End If
        Dim message As String
        message = " ｢" & StrFind & "｣ を、すべて ｢" & strReplace & "｣ に置き換えますか?"
        If MessageBox.Show(message, "置換", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            TextBox1.Text = TextBox1.Text.Replace(StrFind, strReplace)
            TextBox1.Select(0, 0)
            TextBox1.ScrollToCaret()
        End If
    End Sub

    Private Sub HelpIndex()
        Try
            Help.ShowHelp(Me, helpFileName)
        Catch ex As Exception
            MessageBox.Show("ヘルプファイルが見つかりません")
        End Try
    End Sub

    Private Sub HelpAbout()
        Dim aboutform As About = New About()
        aboutform.ShowDialog()
    End Sub

    'ツールバー
    Private Sub ToolStrip1_ItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles ToolStrip1.ItemClicked
        Select Case e.ClickedItem.Tag.ToString
            Case "FileNew"
                FileNew()
            Case "FileOpen"
                FileOpen()
            Case "FileSave"
                FileSave()
            Case "FilePrint"
                PrintPrint()
            Case "EditCut"
                EditCut()
            Case "EditCopy"
                EditCopy()
            Case "EditPaste"
                EditPaste()
            Case "EditFind"
                EditFind()
        End Select
    End Sub

    'ドラッグ操作
    Private Sub Form1_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.All
        End If
    End Sub

    Private Sub Form1_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragDrop
        Dim files() As String = e.Data.GetData(DataFormats.FileDrop)
        Dim path As String = files(0)
        Using reader As New StreamReader(path, System.Text.Encoding.GetEncoding(dat(4)))
            TextBox1.Text = reader.ReadToEnd
            textIsDirty = False
            currentFileName = path
            Me.Text = title & " : " & My.Computer.FileSystem.GetFileInfo(path).Name
            FileName = My.Computer.FileSystem.GetFileInfo(path).Name
            OpenFileDialog1.FileName = FileName
            OpenFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(path).DirectoryName
            SaveFileDialog1.FileName = FileName
            SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.GetFileInfo(path).DirectoryName
        End Using
    End Sub
End Class
